# coding: utf-8

"""
    DLCM-Solution

    DLCM application wrapping all modules, All-In-One  # noqa: E501

    The version of the OpenAPI document: 2.1.1
    Contact: eresearch-opensource@unige.ch
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from dlcmapi_client.configuration import Configuration


class ArchiveStatistics(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'links': 'object',
        'creation': 'ChangeInfo',
        'download_number': 'float',
        'last_update': 'ChangeInfo',
        'res_id': 'str',
        'view_number': 'float'
    }

    attribute_map = {
        'links': '_links',
        'creation': 'creation',
        'download_number': 'downloadNumber',
        'last_update': 'lastUpdate',
        'res_id': 'resId',
        'view_number': 'viewNumber'
    }

    def __init__(self, links=None, creation=None, download_number=None, last_update=None, res_id=None, view_number=None, local_vars_configuration=None):  # noqa: E501
        """ArchiveStatistics - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._links = None
        self._creation = None
        self._download_number = None
        self._last_update = None
        self._res_id = None
        self._view_number = None
        self.discriminator = None

        if links is not None:
            self.links = links
        if creation is not None:
            self.creation = creation
        if download_number is not None:
            self.download_number = download_number
        if last_update is not None:
            self.last_update = last_update
        if res_id is not None:
            self.res_id = res_id
        if view_number is not None:
            self.view_number = view_number

    @property
    def links(self):
        """Gets the links of this ArchiveStatistics.  # noqa: E501

        The _links_ list of the _archive-statistics_ resource  # noqa: E501

        :return: The links of this ArchiveStatistics.  # noqa: E501
        :rtype: object
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this ArchiveStatistics.

        The _links_ list of the _archive-statistics_ resource  # noqa: E501

        :param links: The links of this ArchiveStatistics.  # noqa: E501
        :type: object
        """

        self._links = links

    @property
    def creation(self):
        """Gets the creation of this ArchiveStatistics.  # noqa: E501


        :return: The creation of this ArchiveStatistics.  # noqa: E501
        :rtype: ChangeInfo
        """
        return self._creation

    @creation.setter
    def creation(self, creation):
        """Sets the creation of this ArchiveStatistics.


        :param creation: The creation of this ArchiveStatistics.  # noqa: E501
        :type: ChangeInfo
        """

        self._creation = creation

    @property
    def download_number(self):
        """Gets the download_number of this ArchiveStatistics.  # noqa: E501

        The download number of the archive  # noqa: E501

        :return: The download_number of this ArchiveStatistics.  # noqa: E501
        :rtype: float
        """
        return self._download_number

    @download_number.setter
    def download_number(self, download_number):
        """Sets the download_number of this ArchiveStatistics.

        The download number of the archive  # noqa: E501

        :param download_number: The download_number of this ArchiveStatistics.  # noqa: E501
        :type: float
        """

        self._download_number = download_number

    @property
    def last_update(self):
        """Gets the last_update of this ArchiveStatistics.  # noqa: E501


        :return: The last_update of this ArchiveStatistics.  # noqa: E501
        :rtype: ChangeInfo
        """
        return self._last_update

    @last_update.setter
    def last_update(self, last_update):
        """Sets the last_update of this ArchiveStatistics.


        :param last_update: The last_update of this ArchiveStatistics.  # noqa: E501
        :type: ChangeInfo
        """

        self._last_update = last_update

    @property
    def res_id(self):
        """Gets the res_id of this ArchiveStatistics.  # noqa: E501

        The _archive-statistics_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]  # noqa: E501

        :return: The res_id of this ArchiveStatistics.  # noqa: E501
        :rtype: str
        """
        return self._res_id

    @res_id.setter
    def res_id(self, res_id):
        """Sets the res_id of this ArchiveStatistics.

        The _archive-statistics_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]  # noqa: E501

        :param res_id: The res_id of this ArchiveStatistics.  # noqa: E501
        :type: str
        """

        self._res_id = res_id

    @property
    def view_number(self):
        """Gets the view_number of this ArchiveStatistics.  # noqa: E501

        The view number of the archive  # noqa: E501

        :return: The view_number of this ArchiveStatistics.  # noqa: E501
        :rtype: float
        """
        return self._view_number

    @view_number.setter
    def view_number(self, view_number):
        """Sets the view_number of this ArchiveStatistics.

        The view number of the archive  # noqa: E501

        :param view_number: The view_number of this ArchiveStatistics.  # noqa: E501
        :type: float
        """

        self._view_number = view_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ArchiveStatistics):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ArchiveStatistics):
            return True

        return self.to_dict() != other.to_dict()
